Index: /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1158)
@@ -11,19 +11,21 @@
 #include "netCdfException.hpp"
 #include "exception.hpp"
-
+#include "timer.hpp"
+#include "uuid.hpp"
 namespace xios
 {
       /// ////////////////////// Dfinitions ////////////////////// ///
       CNc4DataOutput::CNc4DataOutput
-         (const StdString & filename, bool exist)
+         (CFile* file, const StdString & filename, bool exist)
             : SuperClass()
             , SuperClassWriter(filename, exist)
             , filename(filename)
-      {
-    SuperClass::type = MULTI_FILE;
+            , file(file),hasTimeInstant(false),hasTimeCentered(false), timeCounterType(none)
+      {
+        SuperClass::type = MULTI_FILE;
       }
 
       CNc4DataOutput::CNc4DataOutput
-         (const StdString & filename, bool exist, bool useClassicFormat, bool useCFConvention,
+         (CFile* file, const StdString & filename, bool exist, bool useClassicFormat, bool useCFConvention,
           MPI_Comm comm_file, bool multifile, bool isCollective, const StdString& timeCounterName)
             : SuperClass()
@@ -32,6 +34,7 @@
             , filename(filename)
             , isCollective(isCollective)
-      {
-    SuperClass::type = (multifile) ? MULTI_FILE : ONE_FILE;
+            , file(file),hasTimeInstant(false),hasTimeCentered(false), timeCounterType(none)
+      {
+        SuperClass::type = (multifile) ? MULTI_FILE : ONE_FILE;
       }
 
@@ -60,5 +63,4 @@
         }
 
-        
          CContext* context = CContext::getCurrent() ;
          CContextServer* server=context->server ;
@@ -78,6 +80,12 @@
          int nvertex = (domain->nvertex.isEmpty()) ? 0 : domain->nvertex;
 
-         StdString dimXid, dimYid ;
-
+
+        StdString dimXid, dimYid ;
+
+        nc_type typePrec ;
+        if (domain->prec.isEmpty()) typePrec =  NC_FLOAT ;
+        else if (domain->prec==4)  typePrec =  NC_FLOAT ;
+        else if (domain->prec==8)   typePrec =  NC_DOUBLE ;
+         
          bool isRegularDomain = (domain->type == CDomain::type_attr::rectilinear);
          switch (domain->type)
@@ -209,10 +217,10 @@
                    {
                      case CDomain::type_attr::curvilinear :
-                       SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                       SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                       SuperClassWriter::addVariable(latid, typePrec, dim0);
+                       SuperClassWriter::addVariable(lonid, typePrec, dim0);
                        break ;
                       case CDomain::type_attr::rectilinear :
-                        SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                        SuperClassWriter::addVariable(lonid, NC_FLOAT, dim1);
+                        SuperClassWriter::addVariable(latid, typePrec, dim0);
+                        SuperClassWriter::addVariable(lonid, typePrec, dim1);
                         break ;
                    }
@@ -230,6 +238,6 @@
                      dim0.push_back(dimXid);
                      dim0.push_back(dimVertId);
-                     SuperClassWriter::addVariable(bounds_lonid, NC_FLOAT, dim0);
-                     SuperClassWriter::addVariable(bounds_latid, NC_FLOAT, dim0);
+                     SuperClassWriter::addVariable(bounds_lonid, typePrec, dim0);
+                     SuperClassWriter::addVariable(bounds_latid, typePrec, dim0);
                    }
                  }
@@ -256,5 +264,5 @@
                  if (domain->hasArea)
                  {
-                   SuperClassWriter::addVariable(areaId, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(areaId, typePrec, dim0);
                    SuperClassWriter::addAttribute("standard_name", StdString("cell_area"), &areaId);
                    SuperClassWriter::addAttribute("units", StdString("m2"), &areaId);
@@ -311,6 +319,6 @@
                        lonid = StdString("nav_lon").append(appendDomid);
                        latid = StdString("nav_lat").append(appendDomid);
-                       SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                       SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                       SuperClassWriter::addVariable(latid, typePrec, dim0);
+                       SuperClassWriter::addVariable(lonid, typePrec, dim0);
                        break;
 
@@ -320,6 +328,6 @@
                        lonid = StdString("lon").append(appendDomid);
                        latid = StdString("lat").append(appendDomid);
-                       SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                       SuperClassWriter::addVariable(lonid, NC_FLOAT, dim1);
+                       SuperClassWriter::addVariable(latid, typePrec, dim0);
+                       SuperClassWriter::addVariable(lonid, typePrec, dim1);
                        break;
                    }
@@ -342,6 +350,6 @@
                      dim0.push_back(dimXid);
                      dim0.push_back(dimVertId);
-                     SuperClassWriter::addVariable(bounds_lonid, NC_FLOAT, dim0);
-                     SuperClassWriter::addVariable(bounds_latid, NC_FLOAT, dim0);
+                     SuperClassWriter::addVariable(bounds_lonid, typePrec, dim0);
+                     SuperClassWriter::addVariable(bounds_latid, typePrec, dim0);
                    }
                  }
@@ -351,5 +359,5 @@
                    dim0.clear();
                    dim0.push_back(dimYid); dim0.push_back(dimXid);
-                   SuperClassWriter::addVariable(areaId, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(areaId, typePrec, dim0);
                    SuperClassWriter::addAttribute("standard_name", StdString("cell_area"), &areaId);
                    SuperClassWriter::addAttribute("units", StdString("m2"), &areaId);
@@ -492,4 +500,9 @@
         if (SuperClass::type==MULTI_FILE) return ;
 
+     nc_type typePrec ;
+     if (domain->prec.isEmpty()) typePrec =  NC_FLOAT ;
+     else if (domain->prec==4)  typePrec =  NC_FLOAT ;
+     else if (domain->prec==8)   typePrec =  NC_DOUBLE ;
+
       std::vector<StdString> dim0;
       StdString domid = domain->getDomainOutputName();
@@ -543,9 +556,9 @@
                 dim0.clear();
                 dim0.push_back(dimNode);
-                SuperClassWriter::addVariable(node_x, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(node_x, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("longitude"), &node_x);
                 SuperClassWriter::addAttribute("long_name", StdString("Longitude of mesh nodes."), &node_x);
                 SuperClassWriter::addAttribute("units", StdString("degrees_east"), &node_x);
-                SuperClassWriter::addVariable(node_y, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(node_y, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("latitude"), &node_y);
                 SuperClassWriter::addAttribute("long_name", StdString("Latitude of mesh nodes."), &node_y);
@@ -562,9 +575,9 @@
                 dim0.clear();
                 dim0.push_back(dimNode);
-                SuperClassWriter::addVariable(node_x, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(node_x, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("longitude"), &node_x);
                 SuperClassWriter::addAttribute("long_name", StdString("Longitude of mesh nodes."), &node_x);
                 SuperClassWriter::addAttribute("units", StdString("degrees_east"), &node_x);
-                SuperClassWriter::addVariable(node_y, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(node_y, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("latitude"), &node_y);
                 SuperClassWriter::addAttribute("long_name", StdString("Latitude of mesh nodes."), &node_y);
@@ -576,9 +589,9 @@
               dim0.clear();
               dim0.push_back(dimEdge);
-              SuperClassWriter::addVariable(edge_x, NC_FLOAT, dim0);
+              SuperClassWriter::addVariable(edge_x, typePrec, dim0);
               SuperClassWriter::addAttribute("standard_name", StdString("longitude"), &edge_x);
               SuperClassWriter::addAttribute("long_name", StdString("Characteristic longitude of mesh edges."), &edge_x);
               SuperClassWriter::addAttribute("units", StdString("degrees_east"), &edge_x);
-              SuperClassWriter::addVariable(edge_y, NC_FLOAT, dim0);
+              SuperClassWriter::addVariable(edge_y, typePrec, dim0);
               SuperClassWriter::addAttribute("standard_name", StdString("latitude"), &edge_y);
               SuperClassWriter::addAttribute("long_name", StdString("Characteristic latitude of mesh edges."), &edge_y);
@@ -602,9 +615,9 @@
                 dim0.clear();
                 dim0.push_back(dimNode);
-                SuperClassWriter::addVariable(node_x, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(node_x, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("longitude"), &node_x);
                 SuperClassWriter::addAttribute("long_name", StdString("Longitude of mesh nodes."), &node_x);
                 SuperClassWriter::addAttribute("units", StdString("degrees_east"), &node_x);
-                SuperClassWriter::addVariable(node_y, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(node_y, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("latitude"), &node_y);
                 SuperClassWriter::addAttribute("long_name", StdString("Latitude of mesh nodes."), &node_y);
@@ -618,9 +631,9 @@
                 dim0.clear();
                 dim0.push_back(dimEdge);
-                SuperClassWriter::addVariable(edge_x, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(edge_x, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("longitude"), &edge_x);
                 SuperClassWriter::addAttribute("long_name", StdString("Characteristic longitude of mesh edges."), &edge_x);
                 SuperClassWriter::addAttribute("units", StdString("degrees_east"), &edge_x);
-                SuperClassWriter::addVariable(edge_y, NC_FLOAT, dim0);
+                SuperClassWriter::addVariable(edge_y, typePrec, dim0);
                 SuperClassWriter::addAttribute("standard_name", StdString("latitude"), &edge_y);
                 SuperClassWriter::addAttribute("long_name", StdString("Characteristic latitude of mesh edges."), &edge_y);
@@ -640,9 +653,9 @@
               dim0.clear();
               dim0.push_back(dimFace);
-              SuperClassWriter::addVariable(face_x, NC_FLOAT, dim0);
+              SuperClassWriter::addVariable(face_x, typePrec, dim0);
               SuperClassWriter::addAttribute("standard_name", StdString("longitude"), &face_x);
               SuperClassWriter::addAttribute("long_name", StdString("Characteristic longitude of mesh faces."), &face_x);
               SuperClassWriter::addAttribute("units", StdString("degrees_east"), &face_x);
-              SuperClassWriter::addVariable(face_y, NC_FLOAT, dim0);
+              SuperClassWriter::addVariable(face_y, typePrec, dim0);
               SuperClassWriter::addAttribute("standard_name", StdString("latitude"), &face_y);
               SuperClassWriter::addAttribute("long_name", StdString("Characteristic latitude of mesh faces."), &face_y);
@@ -906,4 +919,9 @@
          string areaId = "area" + appendDomid;
 
+         nc_type typePrec ;
+         if (domain->prec.isEmpty()) typePrec =  NC_FLOAT ;
+         else if (domain->prec==4)  typePrec =  NC_FLOAT ;
+         else if (domain->prec==8)   typePrec =  NC_DOUBLE ;
+
          int nvertex = (domain->nvertex.isEmpty()) ? 0 : domain->nvertex;
 
@@ -965,6 +983,6 @@
                  if (domain->hasLonLat)
                  {
-                   SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(latid, typePrec, dim0);
+                   SuperClassWriter::addVariable(lonid, typePrec, dim0);
                    this->writeAxisAttributes(lonid, "", "longitude", "Longitude", "degrees_east", domid);
                    if (domain->hasBounds) SuperClassWriter::addAttribute("bounds",bounds_lonid, &lonid);
@@ -978,6 +996,6 @@
                    dim0.push_back(dimXid);
                    dim0.push_back(dimVertId);
-                   SuperClassWriter::addVariable(bounds_lonid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(bounds_latid, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(bounds_lonid, typePrec, dim0);
+                   SuperClassWriter::addVariable(bounds_latid, typePrec, dim0);
                  }
 
@@ -986,5 +1004,5 @@
                  if (domain->hasArea)
                  {
-                   SuperClassWriter::addVariable(areaId, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(areaId, typePrec, dim0);
                    SuperClassWriter::addAttribute("standard_name", StdString("cell_area"), &areaId);
                    SuperClassWriter::addAttribute("units", StdString("m2"), &areaId);
@@ -1021,6 +1039,6 @@
                  if (domain->hasLonLat)
                  {
-                   SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(latid, typePrec, dim0);
+                   SuperClassWriter::addVariable(lonid, typePrec, dim0);
 
                    this->writeAxisAttributes(lonid, "", "longitude", "Longitude", "degrees_east", domid);
@@ -1036,6 +1054,6 @@
                    dim0.push_back(dimXid);
                    dim0.push_back(dimVertId);
-                   SuperClassWriter::addVariable(bounds_lonid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(bounds_latid, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(bounds_lonid, typePrec, dim0);
+                   SuperClassWriter::addVariable(bounds_latid, typePrec, dim0);
                  }
 
@@ -1044,5 +1062,5 @@
                    dim0.clear();
                    dim0.push_back(dimXid);
-                   SuperClassWriter::addVariable(areaId, NC_FLOAT, dim0);
+                   SuperClassWriter::addVariable(areaId, typePrec, dim0);
                    SuperClassWriter::addAttribute("standard_name", StdString("cell_area"), &areaId);
                    SuperClassWriter::addAttribute("units", StdString("m2"), &areaId);
@@ -1111,6 +1129,4 @@
       void CNc4DataOutput::writeAxis_(CAxis* axis)
       {
-        CContext* context = CContext::getCurrent();
-
         if (axis->IsWritten(this->filename)) return;
         axis->checkAttributes();
@@ -1130,11 +1146,20 @@
         else setWrittenAxis(axisid);
 
+        nc_type typePrec ;
+        if (axis->prec.isEmpty()) typePrec =  NC_FLOAT ;
+        else if (axis->prec==4)  typePrec =  NC_FLOAT ;
+        else if (axis->prec==8)   typePrec =  NC_DOUBLE ;
+         
+        if (!axis->label.isEmpty()) typePrec = NC_CHAR ;
+        string strId="str_len" ;
         try
         {
           SuperClassWriter::addDimension(axisid, zoom_size);
+          if (!axis->label.isEmpty()) SuperClassWriter::addDimension(strId, stringArrayLen);
           if (axis->hasValue)
           {
             dims.push_back(axisid);
-            SuperClassWriter::addVariable(axisid, NC_FLOAT, dims);
+            if (!axis->label.isEmpty()) dims.push_back(strId);
+            SuperClassWriter::addVariable(axisid, typePrec, dims);
 
             if (!axis->name.isEmpty())
@@ -1162,5 +1187,5 @@
             {
               dims.push_back("axis_nbounds");
-              SuperClassWriter::addVariable(axisBoundsId, NC_FLOAT, dims);
+              SuperClassWriter::addVariable(axisBoundsId, typePrec, dims);
               SuperClassWriter::addAttribute("bounds", axisBoundsId, &axisid);
             }
@@ -1178,19 +1203,17 @@
               case MULTI_FILE:
               {
-                // CArray<double,1> axis_value(axis->zoom_n);
-                // for (int i = 0; i < axis->zoom_n; i++) axis_value(i) = axis->value(i);
                 SuperClassWriter::writeData(axis_value, axisid, isCollective, 0);
 
-                if (!axis->bounds.isEmpty())
+                if (!axis->bounds.isEmpty() && axis->label.isEmpty())
                   SuperClassWriter::writeData(axis->bounds, axisBoundsId, isCollective, 0);
 
+                // Need to check after
+                if (! axis->label.isEmpty())  SuperClassWriter::writeData(axis->label_srv, axisid, isCollective, 0);
+ 
                 SuperClassWriter::definition_start();
-
                 break;
               }
               case ONE_FILE:
               {
-                // CArray<double,1> axis_value(axis->zoom_n);
-                // axis_value = axis->value;
                 std::vector<StdSize> start(1), startBounds(2) ;
                 std::vector<StdSize> count(1), countBounds(2) ;
@@ -1201,5 +1224,5 @@
                 SuperClassWriter::writeData(axis_value, axisid, isCollective, 0, &start, &count);
 
-                if (!axis->bounds.isEmpty())
+                if (!axis->bounds.isEmpty()&& axis->label.isEmpty())
                 {
                   axis_bounds.resize(2, indexToWrite.numElements());
@@ -1211,4 +1234,7 @@
                   SuperClassWriter::writeData(axis->bounds, axisBoundsId, isCollective, 0, &startBounds, &countBounds);
                 }
+
+                // Need to check after
+                if (! axis->label.isEmpty())  SuperClassWriter::writeData(axis->label_srv, axisid, isCollective, 0);
 
                 SuperClassWriter::definition_start();
@@ -1233,6 +1259,5 @@
           ERROR("CNc4DataOutput::writeAxis_(CAxis* axis)", << msg);
         }
-      
-      axis->addRelFile(this->filename);
+        axis->addRelFile(this->filename);
      }
 
@@ -1247,4 +1272,10 @@
         else setWrittenAxis(scalaId);
 
+        nc_type typePrec ;
+        if (scalar->prec.isEmpty()) typePrec =  NC_FLOAT ;
+        else if (scalar->prec==4)  typePrec =  NC_FLOAT ;
+        else if (scalar->prec==8)   typePrec =  NC_DOUBLE ;
+
+        
         try
         {
@@ -1253,5 +1284,5 @@
 //            dims.push_back(scalaId);
             std::vector<StdString> dims;
-            SuperClassWriter::addVariable(scalaId, NC_FLOAT, dims);
+            SuperClassWriter::addVariable(scalaId, typePrec, dims);
 
             if (!scalar->name.isEmpty())
